<?php

namespace Drupal\pagedesigner\Event;

use Symfony\Component\EventDispatcher\Event;

/**
 * Event that is fired when a pagedesigner is handled.
 */
class ElementEvent extends Event {
  /**
   * The event name.
   *
   * @var string
   */
  protected $eventName = '';

  /**
   * The event data.
   *
   * @var mixed
   */
  protected $data = NULL;

  /**
   * Constructs the object.
   *
   * @param \Drupal\pagedesigner\Entity\Element $entity
   *   The original data.
   * @param \Drupal\pagedesigner\Entity\Element $clone
   *   The clone data.
   */
  public function __construct($eventName, &$data) {
    $this->eventName = $eventName;
    $this->data = &$data;
  }

  /**
   * Returns the event name.
   *
   * @return string
   */
  public function getEventName() {
    return $this->eventName;
  }

  /**
   * Returns the event data.
   *
   * @return mixed
   */
  public function &getData() {
    return $this->data;
  }

}
