<?php

namespace Drupal\pagedesigner\Plugin\pagedesigner\Handler;

use Drupal\Core\Render\Markup;
use Drupal\pagedesigner\Entity\Element;

/**
 * Process entities of type "longtext".
 *
 * @PagedesignerHandler(
 *   id = "longtext",
 *   name = @Translation("Longtext renderer"),
 *   types = {
 *     "textarea",
 *     "longtext"
 *   },
 * )
 */
class Longtext extends Content {

  /**
   * {@inheritdoc}
   */
  public function get(Element $entity, string &$result = '') {
    $result .= Markup::create($entity->field_content->value);
  }

  /**
   * {@inheritdoc}
   */
  public function render(Element $entity, array &$build = []) {
    $value = $this->elementHandler->get($entity);
    $build = ['#plain_text' => ''] + $build;
    if (!empty($value) || strlen($value)) {
      $build['#plain_text'] = $value;
    }
  }

}
