<?php

namespace Drupal\Tests\pagedesigner\Kernel;

use Drupal\KernelTests\KernelTestBase;
use Drupal\Tests\user\Traits\UserCreationTrait;

/**
 * Base class for Kernel Tests.
 *
 * @group pagedesigner
 */
abstract class AbstractPagedesignerTest extends KernelTestBase {
  use UserCreationTrait;

  /**
   * Disable schema checks.
   *
   * @var bool
   */
  protected $strictConfigSchema = FALSE;

  /**
   * Enable the necessary modules for testing.
   *
   * @var array
   */
  protected static $modules = [
    'pagedesigner',
    'ui_patterns',
    'user',
    'node',
    'field',
    'taxonomy',
    'text',
  ];

  /**
   * The base entity created by the test.
   *
   * @var \Drupal\pagedesigner\Entity\Element
   */
  protected $entity = NULL;

  /**
   * Set up environment for Kernel testing.
   *
   * Set up current user, install config and schema for pagedesigner elements.
   */
  public function setUp() {
    parent::setUp();
    $this->setUpCurrentUser();
    $this->installEntitySchema('pagedesigner_element');
    $this->installConfig(['pagedesigner']);
  }

}
